unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Memo1: TMemo;
    SpinEdit1: TSpinEdit;
    procedure FormShow(Sender: TObject);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
      );
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  vFontHeight, vScrollPos, vSelectedLine, vLinePos, vLineLength: Integer;
begin
  // Fontgröße
  if Memo1.Font.Height > 0 then
    vFontHeight := Memo1.Font.Height
  else
    vFontHeight := Memo1.Font.GetTextHeight(Memo1.Text);

  // Position der Vertikalen Scrollbar als "Offset"
  vScrollPos    := Memo1.VertScrollBar.Position;
  // Selektierte Zeile (Y Pixel der Maus / Fontgröße) + Scroll Offset
  vSelectedLine := ( Y div vFontHeight ) + vScrollPos;
  {
   Position des selktierten Textes

   !!! ACHTUNG !!!
   Das hat einen Nachteil, wenn der selbe Text mehrfach vorkommt
   dann springt die Selektion wieder an das erste vorkommen im Memo.
  }
  vLinePos        := Pos(Memo1.Lines[vSelectedLine], Memo1.Text);
  // Länge des Textes wo die Maus ist
  vLineLength     := Length(Memo1.Lines[vSelectedLine]);
  Memo1.SelStart  := vLinePos - 1;
  Memo1.SelLength := vLineLength;



  SpinEdit1.Value:=vFontHeight;
  Label1.Caption:='Text Height:   ' + IntToStr(vFontHeight);
  Label2.Caption:='Mouse Y:       ' + Y.ToString;
  Label3.Caption:='Memo Lines Count: ' + IntToStr(Memo1.Lines.Count - 1);
  Label4.Caption:='Selected Line (Mouse Y Pos): ' + IntToStr(vSelectedLine);
  Label5.Caption:='Scrollbar Pos: ' + Memo1.VertScrollBar.Position.ToString+' ('+Length(Memo1.Lines[vSelectedLine]).ToString+')';
  Label6.Caption:='Selected Text: ' + Memo1.Lines[vSelectedLine];
  Label7.Caption:='Start Pos:     ' + IntToStr(vLinePos);
  Label8.Caption:='Font.Height :  ' + IntToStr(Memo1.Font.GetTextHeight(Memo1.Lines.Text));
end;

procedure TForm1.FormShow(Sender: TObject);
begin

end;

end.

